//**********************************
//    StartCd.narod.ru 
//**********************************
//v1.43      
//v1.42 +   / .
//v1.41 + , .
//v1.03 mega8 5  18.09.2007
//   DS18B20 (3.11.07)

#include "clock5.h"
//
//**************************************
ISR(SIG_OVERFLOW0){//0,000064

	if (++lcd_time_switch == light_isr) PORTLED=znakomesto_isr;	
	
}
//**************************************
ISR(SIG_OVERFLOW2)
{
 clock_++;
 if (clock_==128)//128
	{	   	 		  	   	  				   	
	clock_=correct;
	isr_1sek_=1;
  	}
}
//--------------------------------------
void port_init(void)
{
	DDRLED=0xFF;
	DDRKEY=0;
	PORTKEY=KEY;
	DDR_BUDIL|=PIN_BUDILNIK;
	INIT_DDR_TSTAT;
	INIT_DDR_HOUR;
	PORT_POWER_DETECT|=_power_;
}

//**************************************
void timer2_init(void)
{
	TCCR2 = 0x00; 		  //stop
	ASSR  = (1<<AS2);	  //set async mode
	TCCR2 = 0x01; 		  //start
}
//**************************************
void timer1_init(void)
{
	TCCR1B = 0; //stop
	TCCR1A = 0;
 //OCR1AH = ocr1[ocr1ahi];
 //OCR1AL = ocr1[ocr1alow];
	DDR_OC1A  &=~ OC1A;	  //OC1A 
	PORT_OC1A &=~ OC1A;
}
/**************************************
void timer1_init_in_pwm(void)
{
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
}
**************************************/	
void shim_true(void){
	//timer1_init_in_pwm();
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
	TCCR1B=(1<<CS10)|(1<<WGM12);
}
//**************************************

void init_devices(void)
{
	cli();
	port_init();
	TCCR0=0x01;
	OCR1A=0x0400;
	timer1_init();
	MCUCR = 0x00;
	GICR  = 0x00;
	ACSR=BIT(ACD);
	TIMSK =(1<<TOIE2)|(1<<TOIE0); //(1<<OCIE2)| timer interrupt sources |(1<<OCIE1A)
	sei(); 
}

//**************************************
//   
unsigned char EEPROM_READ(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));/*     */
	EEAR = uiAddress;/*    */
	EECR |= (1<<EERE);/*       EERE */
	return EEDR;/*      */
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		/*     */
		while(EECR & (1<<EEWE));
		cli();
		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		sei();
		}
}
//*********************************************
void read_data_EEPROM(void)
{
unsigned char  *a, i;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=0 ; i<sizeof(setup); i++, a++){
		*a=EEPROM_READ(i);
		if (i<sizeof(setup)-2){
			crc+=*a;
			}
		}
	if ( crc!=setup.crc ) eeprom_err=1;
}

void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p;
 
	if (time_flag & fl_eeprom_write)
	{
	time_flag&= ~fl_eeprom_write;
	setup.crc=eeprom_err=0;
	TIMSK &= ~(1<<TOIE0);
	p=(unsigned char *) &setup;
	for(i=0; i<sizeof(setup) ; i++, p++){
		EEPROM_write( i, *p );
		if (i<sizeof(setup)-2)
			setup.crc+=*p;
		}
	TIMSK |= (1<<TOIE0); 
	}
}

void pullup_off(void){
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	DDR_1wire&=~pwire2;
	PORT_1wire&=~pwire0;
	PORT_1wire&=~pwire1;
	PORT_1wire&=~pwire2;
}

unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down

	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~out_1wire;//line up through 1.25us
	_delay_us(12);
	i=PIN_1wire;
	sei();
	_delay_us(47);
	return i;
}


void readbyte(unsigned char *pw) {
unsigned char i,r,p;//, a;

pw[0]=pw[1]=pw[2]=0;
pullup_off();
for(i=0, r=1; i<8; i++){
	p=readbit();
	//for(a=0; a<kolvo_datchikov; a++)
	//	if ( p & BIT(a) ) *(pw0+a)|=r; else *(pw0+a)&=~r;
	if ( p & pwire0 ) pw[0]|=r; 
	if ( p & pwire1 ) pw[1]|=r; 
	if ( p & pwire2 ) pw[2]|=r;
	r<<=1;	
	}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
}

//------------------------------------------------
void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);
	DDR_1wire&=~out_1wire;
	sei();
}
//***********************************************
void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(57);
}
//***********************************************
void writebyte(unsigned char byte){
unsigned char i;
	pullup_off();
	for(i=0; i<8; i++){
		if (byte&BIT(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}

void detectPresence(void){
unsigned char i;
	
	pullup_off();
	out_1wire=pwire0|pwire1|pwire2;
	
	DDR_1wire|=pwire0;
	DDR_1wire|=pwire1;
	DDR_1wire|=pwire2;
	_delay_ms(0.48);//0.48
	
	cli();
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	DDR_1wire&=~pwire2;
	_delay_us(60);//60
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) out_1wire&=~pwire0;
	if ( i & pwire1 ) out_1wire&=~pwire1;
	if ( i & pwire2 ) {out_1wire&=~pwire2; PORT_TSTAT &= ~PIN_TSTAT;}

	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & pwire0 )) out_1wire&=~pwire0;
	if (!( i & pwire1 )) out_1wire&=~pwire1;
	if (!( i & pwire2 )) {out_1wire&=~pwire2; PORT_TSTAT &= ~PIN_TSTAT;}
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
			
	power_suplly_1w &= out_1wire;
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;	
}

//****************************************
void scratchpad_save(void){

	detectPresence();//  
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
	writebyte(5);//	TH
	writebyte(5);//	TL
	writebyte(0x7F);//	Statys 12bit
		
	detectPresence();//   EEPROM
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x48);//COPY SCRATCHPAD [48h]
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}

//**************************************************
void format_t(unsigned char p){
int t;
	t=((unsigned int)(tempir_msb[p]<<8))|tempir_lsb[p];//msb
	temperatura[p]=t*10>>4;
}	
//**************************************************
void izmerenie_t(void)
{
if ( !count_com_1w ){//
	count_com_1w++;
	power_suplly_1w=0;
	detectPresence();//  
	}
	else
	if ( count_com_1w==1 ){
		count_com_1w++;
	
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xB4);//READ POWER SUPPLY [B4h]
		pullup_off();
		
		power_suplly_1w=readbit();//     
		power_suplly_1w=~power_suplly_1w;//    ,  
		power_suplly_1w &= out_1wire;//pwire0|pwire1;
		}
	else
	if ( count_com_1w==2 ){	// 
		count_com_1w++;
		detectPresence();//
		}
	else
	if ( count_com_1w==3 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		time[wire1]=125;//1sek
		}
	else
	if ( count_com_1w==4 ){
		if (time[wire1]<-10) count_com_1w++;
		}
	else
	if ( count_com_1w==5 ){// 
		count_com_1w++;
		detectPresence();//
		}
	else
	if ( count_com_1w==6 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		}
	else
	if ( count_com_1w==7 ){
		count_com_1w=0;

		readbyte(&tempir_lsb[0]);//LSB   
		readbyte(&tempir_msb[0]);//MSB   
	
		format_t(0);
		format_t(1);
		format_t(2);

		if ( out_1wire & pwire2 )
			{
			if ( !(regim==r_porog+4) )
				{
				//--------------------------------------------------------
				if (temperatura[2] <= setup.porog[0] )	PORT_TSTAT |= PIN_TSTAT;
				else
				if (temperatura[2] >= setup.porog[1] )	PORT_TSTAT &= ~PIN_TSTAT;
				//--------------------------------------------------------
				}
			}
			else PORT_TSTAT &= ~PIN_TSTAT;
		}
}
//*************** END 1 Wire ***************************************************

void change_light_var(void)
{
	if ( time_flag & fl_plus )
		   {
		   if (++change_light>=lcd_light) time_flag &= ~fl_plus;//    
		   }
		   else
		   {
		   if (change_light>1) change_light--; else time_flag|= fl_plus;//  
		   }
}
//**************************************
unsigned char opred_light_current_num(void)
{
  unsigned char l;
  unsigned char a=_BV(4);
 	
	l=lcd_light;

	if (mask)
	 	{
		a>>=znakomesto;
		if ( mask&a ) l=change_light;
		}
		else	
		{
		time_flag &= ~fl_plus;
		change_light=lcd_light;
		}
	return l;
}


//******************74hc595***********************************
void data_shift(unsigned char data)
{
	unsigned char i=0; 
	for(i=8; i ; i--){//   8 
	if (data & BIT(7) )  	PORTSERIAL|=BIT(DATA);
                    else	PORTSERIAL&=~BIT(DATA); 
	data<<=1;
	PORTSERIAL|=BIT(SHIFT);
	//asm("nop");
	PORTSERIAL&=~BIT(SHIFT);
	} 
}

void display(void)
{
	PORTSERIAL|=BIT(STORAGE);// 
#ifdef katod 
	data_shift( lcd_buffer[znakomesto] );
#else
	data_shift(~lcd_buffer[znakomesto] );
#endif
	
	PORTSERIAL&=~BIT(STORAGE);
	PORTSERIAL|=BIT(STORAGE);
	PORTSERIAL&=~PIN_SERIAL;//(BIT(DATA)|BIT(SHIFT)|BIT(STORAGE));  
}

//*************************************************************
void bip_sig_on(uint8_t t){
	shim_true();//
	time_flag|= fl_sig_butt ;
	time[note_but]=t;
}
//*************************************************************
void skankey (void){
	unsigned char key_lokal=17;
	
	key=key_lokal;

	if 			(KEY_F)	    	key_lokal=1;
	else if	(KEY_SET)		key_lokal=2;
	else if	(KEY_PLUS)		key_lokal=3;
	else if	(KEY_MINUS)		key_lokal=4;
	else 						key_lokal=17;
	
	if ( key_lokal!=17 )
	{
	anti_drebezg[0]++;
	if (anti_drebezg[0]==7)//35)
		{
		key=key_lokal;
		bip_sig_on(7);
		}
	if (anti_drebezg[0]==anti_drebezg[2]){	//anti_drebezg[0]  
		anti_drebezg[0]=0;					//anti_drebezg[1] -   
		anti_drebezg[1]++;					//anti_drebezg[2]    
		if (anti_drebezg[1]==3) anti_drebezg[2]=15;//55;
		}	
	time_in_regim=25;
	}
	else
	{
	anti_drebezg[0]=0;
	anti_drebezg[1]=0;
	anti_drebezg[2]=50;
	}
}

/**************************************
void inc_dec_var_bit(unsigned char *var,unsigned char bit_n){
		if (PLUS)	 (*var)|= BIT(bit_n);
		if (MINUS) 	 (*var)&=~BIT(bit_n);
}
*/
//**************************************
void inc_dec_var(unsigned char *var, unsigned char limit){
	if (PLUS){
		if ((*var)<limit)	(*var)++; 
		else *var=0;
		}
	if (MINUS){
		if (*var) (*var)--;
		else *var=limit;
		}
}
//**************************************
//*
void inc_dec_porog(signed int *p){
uint8_t i; 		
		if (anti_drebezg[2]==15) i=10; else i=1;
		if (PLUS){
			if (*p<1250)	(*p)+=i; 
			else *p=0;
			}
		if (MINUS){
			if (*p>-550) (*p)-=i;
			else *p=0;
			}
}
//*/
//**************************************
void mask_next_regim(unsigned char m, unsigned char next_F,unsigned char SET)
{
 	if (!anti_drebezg[0])  mask=m; 
	if (F_)   regim=next_F;
	if (SET_) regim=SET;
	key=17;
}

void next_regim(void){
	if (PLUS) {
		if (regim<END_REGIM) 
		regim++;
		} 
	if (MINUS) {
		if (regim>FIRST_REGIM)
		regim--;
		} 
	p_index=0;
}
/*
void EEPROM_save_parametr( unsigned char adres, unsigned char *p, unsigned char byte ){
 unsigned char i;
 unsigned int crc=0;
 byte+=adres;
	for(i=adres; i<byte ; i++, p++){
		EEPROM_write( i, *p );
		if (i<byte) crc+=*p;
		}
	EEPROM_write( i++, (unsigned char)(crc>>8) );
	EEPROM_write( i, (unsigned char)crc );
}
*/

//**************************************
void key_action(void)
{//mask_next_regim( maska regima, if (key F_), if (key SET_) )
unsigned char *p,i;	
	mask=0;
	

	if ( regim == 0 ){ 
		p_index=0;
		
		if ( F_ )
			if (signal==3)	 {signal=0; return;}
			
		if ( !(time_flag & fl_power_save) ){
			if ( F_ ) regim=FIRST_REGIM;
			if (MINUS) regim=r_budilnik;
			if (PLUS) {regim=r_yst_see; current_state_view.regim=0;}
			}
		
		return;
		}
	
	if (regim==REG_BUDILNIK_ON){
		mask=0xFF;
		if ( F_ ){ 
			regim=signal=0;
			BUDIL_OUT_OFF;
			}
		if (( PLUS )||( MINUS )||( SET_ )){
			BUDIL_OUT_OFF;
			regim=0;
			if (signal>1){
				signal=3;
				time_signal=0xFF;
				budilnik_play_num=0;
				}
				else
				signal=0;
			}
		return;
		}
	
	if (regim==REG_BUDILNIK){
		next_regim();
		mask_next_regim(0xFF,0,r_budilnik);	
		return;
		}
	if (regim==r_budilnik) {//  
		inc_dec_var(&p_index, Count_bud-1);
		mask_next_regim(0x10, 0,r_budilnik+1);	
		return;
		}
	if (regim==r_budilnik+1) {// /
		inc_dec_var(&setup.budilnik[p_index][0],2 );
		mask_next_regim(0x10,r_budilnik,r_budilnik+2);	
		return;
		}
	if (regim==r_budilnik+2) {
		inc_dec_var(&setup.budilnik[p_index][h_hour], 23);
		mask_next_regim(0x0C,r_budilnik,r_budilnik+3);	
		return;
		}
	if (regim==r_budilnik+3) {
		x_index=0;
		inc_dec_var(&setup.budilnik[p_index][h_min], 59);
		mask_next_regim(0x3,r_budilnik,r_budilnik+4);	
		return;
		}
	if (regim==r_budilnik+4) {
		mask=0x08;//if (!anti_drebezg[0])  mask=0x08; 
		if (PLUS)	 setup.budilnik[p_index][h_day]|= _BV(x_index);
		if (MINUS) 	 setup.budilnik[p_index][h_day]&=~_BV(x_index);
		if (SET_) x_index++;	
		if (x_index==7) regim=r_budilnik;
		if (F_) regim=r_budilnik;
		return;
		}
		
	//----------clock-----------------
	if (regim==REG_CLOCK) {
		next_regim();
		mask_next_regim(0xFF,0,r_clock);	
		return;
		}
	if (regim==r_clock) {//
		if (MINUS){
		   if (hour[h_sek]>31) hour[h_min]++;
		   hour[h_sek]=0;
		   clock_=0;
		   }
		mask_next_regim(0x03,REG_CLOCK,r_clock+1);	
		return;
		}
	if (regim==r_clock+1) {//
		inc_dec_var(&hour[h_min],59);
		mask_next_regim(0x03,REG_CLOCK,r_clock+2);	
		return;
		}
	if (regim==r_clock+2) {//
		inc_dec_var(&hour[h_hour],23);
		mask_next_regim(0x18,REG_CLOCK,r_clock+3);	
		return;
		}
	if (regim==r_clock+3) {//
		inc_dec_var(&hour[h_month],11);
		mask_next_regim(0x03,REG_CLOCK,r_clock+4);	
		return;
		}
	if (regim==r_clock+4) {//
		inc_dec_var(&hour[h_num],30);
		mask_next_regim(0x0C,REG_CLOCK,r_clock+5);	
		return;
		}
	if (regim==r_clock+5) {// 
		inc_dec_var(&hour[h_day],7-1);
		mask_next_regim(0x10,REG_CLOCK,r_clock+6);	
		return;
		}
		
	if (regim==r_clock+6) {//set corection znak
	 	inc_dec_var(&setup.corr_flag, 1);
	 	mask_next_regim(0x10,REG_CLOCK,r_clock+7);
		return;
		}
	if (regim==r_clock+7) {//set hour
	 	inc_dec_var(&setup.correction,sizeof(corr_in_lcd)/2-1);
	 	mask_next_regim(0x0F,REG_CLOCK,REG_CLOCK);
		return;
		}

	//--------------------------
	if (regim==REG_POROG) {//
		next_regim();
		mask_next_regim(0xFF,0,r_porog+1);//	
		return;
		}

	if (regim==r_porog+1) {//
		inc_dec_var(&p_index,2);
		if (p_index==2) regim=r_porog+4;
		mask_next_regim(BIT(4),REG_POROG,r_porog+2);	
		return;
		}
	if (regim==r_porog+2) {
		inc_dec_porog(&setup.porog[p_index]);
		mask_next_regim(0X0F,r_porog+1,r_porog+1);
		return;
		}
	/*if (regim==r_porog+3) {
		inc_dec_porog(&setup.porog[p_index+1]);
		mask_next_regim(0x0F,r_porog+1,r_porog+1);
		return;
		}
	*/
	if (regim==r_porog+4) {
		p_index=0;
		if (PLUS) PORT_TSTAT |= PIN_TSTAT;
		if (MINUS) PORT_TSTAT &= ~PIN_TSTAT;
		mask_next_regim(0x02,r_porog+1,r_porog+1);
		return;
		}

	//----------------SEE------------------------------
	if (regim==REG_YST_SEE){//122
		next_regim();
		mask_next_regim(0xFF,0,r_yst_see);//_t_SEE_
		current_state_view.regim=0;
		return;
		}
	if (regim==r_yst_see) {//. 
	 	inc_dec_var( &current_state_view.regim, Count_regim-1 );
	 	mask_next_regim(0x10,0,r_yst_see+1);
		return;
		}	
	if (regim==r_yst_see+1) {//regim 
	 	inc_dec_var( &setup.state_regim[current_state_view.regim],11 );
	 	mask_next_regim(0x08,r_yst_see,r_yst_see+2);
		return;
		}	
	if (regim==r_yst_see+2) {//time
	 	inc_dec_var( &setup.state_time[current_state_view.regim],99 );
	 	mask_next_regim(0x06,r_yst_see,r_yst_see+3);
		return;
		}
	if (regim==r_yst_see+3) {//skip
	 	inc_dec_var( &setup.state_skip[current_state_view.regim],9 );
	 	mask_next_regim(0x01,r_yst_see,r_yst_see);
		return;
		}

	//=============LIGHT===============
	if (regim==REG_LIGHT) {
		next_regim();
		mask_next_regim(0xFF,0,r_light);
		return; 
		}
	if (regim==r_light) {
		inc_dec_var( &setup.day_light, sizeof(light_disp)-1 );
		mask_next_regim(0x01,REG_LIGHT,r_light+1); 
		return;
		}
	if (regim==r_light+1) {
		inc_dec_var( &setup.night_light,7);
		mask_next_regim(0x01,REG_LIGHT,r_light+2); 
		return;
		}
	if (regim==r_light+2) {
		inc_dec_var( &setup.tim_c_light,23);
		mask_next_regim(0x03,REG_LIGHT,r_light+3); 
		return;
		}
	if (regim==r_light+3) {
		inc_dec_var( &setup.tim_do_light,23);
		mask_next_regim(0x03,REG_LIGHT,REG_LIGHT); 
		return;
		}	
	
	//============================
	if (regim==REG_HOUR) {
		next_regim();
		mask_next_regim(0xFF,0,r_hour);
		return; 
		}
	
	if (regim==r_hour) {// P (Pin)   PIN_HOUR,     1    
		inc_dec_var( &setup.kukuschka[0],1);
		mask_next_regim(0x10,REG_HOUR,r_hour+1); 
		return;
		}
	if (regim==r_hour+1) {// b (budilnik)     2 
		inc_dec_var( &setup.kukuschka[1],1);
		mask_next_regim(0x04,REG_HOUR,r_hour+2); 
		return;
		}
	if (regim==r_hour+2) {//  ()      
		inc_dec_var( &setup.kukuschka[2],1);
		mask_next_regim(0x01,REG_HOUR,REG_HOUR); 
		return;
		}
	
	//=============ds18b20===============
	if (regim==REG_DS18B20) {//126
		next_regim();
		mask_next_regim(0xFF,0,r_ds18b20);
		return; 
		}//ds18b20	
	if (regim==r_ds18b20) {
		inc_dec_var( &p_index, kolvo_datchikov-1);
		mask_next_regim(0x08,REG_DS18B20,r_ds18b20+1); 
		if (regim==r_ds18b20+1) {
			scratchpad_save();		 
			regim=REG_DS18B20;
			}
		return;
		}

	if (regim==REG_SBROS_N){//122
		next_regim();
		mask_next_regim(0xFF,0,REG_SBROS_N+1);
		if (regim==REG_SBROS_N+1){
			p=(unsigned char *) &setup;
			for(i=0; i<sizeof(setup) ; i++, p++)
				*p=0;
			setup.day_light	=7;
			setup.night_light	=3;
			setup.tim_c_light	=23;
			setup.tim_do_light	=6;
			regim=0;
			}
		return;
		}	
}

//****************************************
void result_in_bcd(int result)
{
    unsigned char dig_out=0;
	bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;
	while (result >= 10000) {
	 result -= 10000;
 	 dig_out ++;
	}
	bcd_num0=dig_out;
    dig_out = 0;
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	bcd_num1=dig_out;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4=result;
}
//**************************************
void cls_lcd_buffer(void){
unsigned char i;
 for(i=0;i<5;i++){
	lcd_buffer[i]=0;
	}
}
//**************************************
void load_str_in_lcdbuffer(const unsigned char *str_lcd){
unsigned char b, a;
	for( b=0, a=1 ; b<str_lcd[0] ; b++, a++){
		lcd_buffer[b]=str_lcd[a];
		}
}
//**************************************
void num2_bcd_in_lcd(unsigned char znak_mesto, unsigned char param_out)
{
 	result_in_bcd(param_out);
	lcd_buffer[znak_mesto]=font[bcd_num3];
	lcd_buffer[znak_mesto+1]  =font[bcd_num4];
}
//----------------------------------------------------------------


//**************************************
void tempir_in_bcd(signed int t, unsigned char mesto, unsigned char pin_wire, unsigned char point){
unsigned char  znak=0, n1=0,n2=0;

	if ( !(pin_wire & out_1wire) ){
	 	lcd_buffer[mesto]	=font[f_seg_g];
		lcd_buffer[mesto+1]	=font[f_seg_g];
		lcd_buffer[mesto+2]	=font[f_seg_g];
		}
		else
		{
		if ( t<0 ){
			znak=1;
			result_in_bcd( t * -1 );
			}
		else 
			result_in_bcd( t );

		if ( bcd_num1 ) {
			n1=font[bcd_num1];
			n2=font[bcd_num2];
			}
		else
		{
		if ( bcd_num2 ){ 
			n2=font[bcd_num2]; 
			if ( znak ) n1=font[f_seg_g];
			}
			else
			if ( znak ) n2=font[f_seg_g];
		}

		lcd_buffer[mesto]=n1;
		lcd_buffer[mesto+1]=n2;
		lcd_buffer[mesto+2]=font[bcd_num3];//|tochka;
		lcd_buffer[mesto+3]=font[bcd_num4];
		
		if (point) lcd_buffer[mesto+2]^=tochka;
			else if (bcd_num4>5) lcd_buffer[mesto+2]^=tochka;
		}
}
//---------------------------------------------
void temper_tstat(void){
	lcd_buffer[0]=font[f_t];
	tempir_in_bcd(temperatura[2],1,pwire2, 1);
}

void temper_d(unsigned char point){
	lcd_buffer[0]=font[f_d];
	tempir_in_bcd(temperatura[0],1,pwire0, point);
	if (!point) lcd_buffer[4]=font[f_gr];
}

void temper_u(unsigned char point){
	lcd_buffer[0]=font[f_y];
	tempir_in_bcd(temperatura[1],1,pwire1, point);
	if (!point) lcd_buffer[4]=font[f_gr];
}

void temper_gr(unsigned char dsX, unsigned char pwire){
	tempir_in_bcd(temperatura[dsX],0,pwire, 0);
	lcd_buffer[3]=font[f_gr];
	lcd_buffer[4]=font[f_C];
}
//---------------------------------------------

//---------------------------------------------
void blank_nul(unsigned char mesto){
	if (lcd_buffer[mesto]==font[n0]) 
		lcd_buffer[mesto]=0;
}
//---------------------------------------------
void hh_mm(void){
	num2_bcd_in_lcd(0,hour[h_hour]);
	blank_nul(0);
	#ifdef miganie
 	if ( time_flag & fl_sek_1_switch )
	#endif
		lcd_buffer[2]=font[f_seg_g];
	num2_bcd_in_lcd(3,hour[h_min]);
}

void mm_ss(void){
	num2_bcd_in_lcd(0,hour[h_min]);
	//blank_nul(0);
	lcd_buffer[2]=font[f_seg_g];
	num2_bcd_in_lcd(3,hour[h_sek]);
}

void dd_month(unsigned char d_nedeli){
	if (d_nedeli) lcd_buffer[0]=tochka^font[hour[h_day]+1]; //  , , 
	num2_bcd_in_lcd(1,hour[h_num]+1);
	if (!d_nedeli) blank_nul(1); //   .     .  01,01 -> 1,01
	lcd_buffer[2]^=tochka;
	num2_bcd_in_lcd(3,hour[h_month]+1);
}

void dd_nedeli(void){
	num2_bcd_in_lcd(0,hour[h_num]+1);
	blank_nul(0);
	lcd_buffer[3]=h_day_str[(hour[h_day])*2];
	lcd_buffer[4]=h_day_str[(hour[h_day])*2+1];
}

void budil_str(unsigned char mesto){
	if (setup.budilnik[p_index][0]==0) lcd_buffer[mesto]=font[f_seg_d];
		else
	if (setup.budilnik[p_index][0]==1) lcd_buffer[mesto]=0x24;
		else
	if (setup.budilnik[p_index][0]==2) lcd_buffer[mesto]=font[f_gr];
		
	num2_bcd_in_lcd(mesto+1,setup.budilnik[p_index][h_hour]);
	lcd_buffer[mesto+2]^=tochka;
	num2_bcd_in_lcd(mesto+3,setup.budilnik[p_index][h_min]);
	blank_nul(mesto+1);
}

//*************************************
void power_in_lcd(unsigned char pin_wire){
unsigned char a,b;
	if ( !(pin_wire & out_1wire) ){
		a=font[f_seg_g];
		b=font[f_seg_g];
		}
		else
		if (power_suplly_1w & pin_wire )
		{
		a=font[f_P];
		b=font[f_A];	
		}
		else{
		a=font[f_o];
		b=font[f_n];
		}
	lcd_buffer[3]=a;
	lcd_buffer[4]=b;
}

//**************************************
void view_in_indikator(unsigned char view){
	if 			(view==0)	hh_mm();
	else 	if 	(view==1)	mm_ss();
	else 	if 	(view==2)	dd_month(1);
	else 	if 	(view==3)	dd_month(0);
	else 	if 	(view==4)	dd_nedeli();
	else 	if 	(view==5)	temper_d(1);
	else	if	(view==6)	temper_d(0);
	else	if	(view==7)	temper_u(1);
	else	if	(view==8)	temper_u(0);
	else	if	(view==9)	temper_gr(0, pwire0);
	else	if	(view==10)	temper_gr(1, pwire1);
	else	if	(view==11)	temper_tstat();
	else	hh_mm();//default
	/*
	switch (view)
	{
	case(0):hh_mm(); break;
	case(1):mm_ss(); break;
	case(2):dd_month(1); break;
	case(3):dd_month(0); break;
	case(4):dd_nedeli(); break;
	case(5):temper_d(1); break;
	case(6):temper_d(0); break;
	case(7):temper_u(1); break;
	case(8):temper_u(0); break;
	case(9):temper_gr(0, pwire0); break;
	case(10):temper_gr(1, pwire1); break;
	case(11):temper_tstat(); break;
	default:
	hh_mm();//default
	}
	//*/
}

//--------------------------------------
void indikator_manager(void){
unsigned char i, a;

	a=i=current_state_view.regim;	//  
	if ( ++i>=Count_regim ) i=0; //     ,  .
	
	while ( i!=a )
		{
		if (current_state_view.regim==a)
			{
			if  (setup.state_time[i] > 0)
				{
				if (current_state_view.skip[i]) //   , 
					current_state_view.skip[i]--;//   	 
					else
					{
					current_state_view.regim=i;
					break;
					}
				}
			}
		if ( ++i>=Count_regim ) i=0;
		}
	
	i=current_state_view.regim;
	//if (i==a) 
	//i=0;//    ,    = 0
	current_state_view.time=		setup.state_time[i];
	current_state_view.skip[i]=		setup.state_skip[i];
	current_state_view.viewstate=	setup.state_regim[i];
}

//**************************************/
void data_lcd(void)
{
static uint8_t state_view_init=0;

 	cls_lcd_buffer();

	if (regim==0)
		{
		if ( state_view_init ){
			state_view_init=0;
			current_state_view.viewstate= 0;
			current_state_view.time = 2;
			for(uint8_t i=0; i<Count_regim; i++)
					current_state_view.skip[i]=0;
			}
		if (eeprom_err){
			lcd_buffer[1]=font[f_E];
			lcd_buffer[2]=font[f_E];
			lcd_buffer[3]=font[f_P];
			}
			else
			{
			view_in_indikator(current_state_view.viewstate);
			if (signal==3) 
				if ( !(time_flag & fl_sek_1_switch) )
					lcd_buffer[4]^=tochka;
			}
		return;
		}
		else	state_view_init=1;
		
	
	//-----------------------------------------------
	if (regim==REG_CLOCK){
		load_str_in_lcdbuffer(str_clock);
		return;
	    } 
	if ( regim == r_clock ) 
		{
		load_str_in_lcdbuffer(str_sec);
		num2_bcd_in_lcd(3,hour[h_sek]);
		return;
		}
	if ( (regim >= r_clock+1 ) && (regim <= r_clock+2) ) 
		{
		hh_mm();
		return;
		}
	if ( (regim >= r_clock+3 ) && (regim <= r_clock+5) ) 
		{
		dd_month(1);
		return;
		}
	if ( (regim >= r_clock+6 ) && (regim <= r_clock+7) ) 
		{
		if ( setup.corr_flag )		lcd_buffer[0]=font[f_seg_d]; 
	   	  else				   	 	lcd_buffer[0]=font[f_seg_g];   
		lcd_buffer[1]=font[n0]^tochka; 
		result_in_bcd( pgm_read_word_near(&corr_in_lcd[setup.correction]) );
		lcd_buffer[2]	=font[bcd_num2];
		lcd_buffer[3]  	=font[bcd_num3];
		lcd_buffer[4]  	=font[bcd_num4];
		return;
		}
	
	//----------------------------------------------------------------
	if (regim==REG_YST_SEE){
	    load_str_in_lcdbuffer(str_yst_see);
		return;
	    }
	if ( (regim >= r_yst_see ) && (regim <= r_yst_see+3) ) 
		{
		lcd_buffer[0]=font[current_state_view.regim+1]^tochka;
		lcd_buffer[1]=font[ setup.state_regim[current_state_view.regim] ]^tochka;
		num2_bcd_in_lcd(2, setup.state_time[current_state_view.regim] );
		lcd_buffer[3]^=tochka;
		lcd_buffer[4]=font[ setup.state_skip[current_state_view.regim] ];
		
		return;
		}
	//-------------------------------------------------
	if (regim==REG_POROG){
	    load_str_in_lcdbuffer(str_tstat);
		return;
	    }
	if ( (regim >= r_porog ) && (regim <= r_porog+3) ) 
		{
		lcd_buffer[0]=font[p_index]^tochka;
		tempir_in_bcd( setup.porog[p_index],1,pwire2, 1);
		return;
		}
	if (regim==r_porog+4){
		lcd_buffer[0]=font[3]^tochka;
		
		lcd_buffer[2]=font[f_P];
		if (PORT_TSTAT&PIN_TSTAT)
			lcd_buffer[3]=font[1];
			else
			lcd_buffer[3]=font[0];
		return;
		}
	//-------------------DS18B20------------------------------
	if (regim==REG_DS18B20){
		load_str_in_lcdbuffer(str_ds18b20);
		return;
		}
	if (regim==r_ds18b20){
		lcd_buffer[0]=font[f_d]^tochka;
		lcd_buffer[1]=font[p_index+1];
		if (p_index==0) power_in_lcd(pwire0);
		else
		if (p_index==1) power_in_lcd(pwire1);
		else 			 power_in_lcd(pwire2);
		return;
		}
	//-----------------------------------------
	if (regim==REG_LIGHT){
		load_str_in_lcdbuffer(str_light);
		return;
		}
	if (regim==r_light){
		load_str_in_lcdbuffer(str_light_day);
		lcd_buffer[4]=font[setup.day_light];
		lcd_light=setup.day_light;
		return;
		}
	if (regim==r_light+1){
		load_str_in_lcdbuffer(str_light_night);
		lcd_buffer[4]=font[setup.night_light];
		lcd_light=setup.night_light;
		return;
		}
	if (regim==r_light+2){
		lcd_buffer[1]=font[f_c];
		num2_bcd_in_lcd(3, setup.tim_c_light );
		return;
		}
	if (regim==r_light+3){
		lcd_buffer[0]=font[f_n];
		lcd_buffer[1]=font[f_o];
		num2_bcd_in_lcd(3, setup.tim_do_light);
		return;
		}
	//-----------------------------------------------
	if (regim==REG_BUDILNIK_ON){
		hh_mm();
		lcd_buffer[2]=font[f_seg_g];
		return;
		}
	if (regim==REG_BUDILNIK){
		load_str_in_lcdbuffer(str_budil);
		return;
		}
	if (regim==r_budilnik){
		lcd_buffer[0]=font[p_index+1];
		budil_str(1);
		return;
		}
	if ( (regim >= r_budilnik+1 ) && (regim <= r_budilnik+3) ){
		budil_str(0);
		return;
		}
	if ( (regim>=r_budilnik+4)&&(regim<=r_budilnik+4+7) ){
		lcd_buffer[0]=font[p_index+1];
		if ( setup.budilnik[p_index][h_day] & _BV(x_index) )
			lcd_buffer[1]=font[f_o];
			else
			lcd_buffer[1]=font[f_seg_d];
		lcd_buffer[3]=h_day_str[x_index*2];
		lcd_buffer[4]=h_day_str[x_index*2+1];
		return;
		}
	//----------------------------------------
	if (regim==REG_HOUR){
		load_str_in_lcdbuffer(str_hour);
		return;
		}
	if ( (regim>=r_hour)&&(regim<=r_hour+2) ){
		if (setup.kukuschka[0])
			lcd_buffer[0]=font[f_P];			
			else
			lcd_buffer[0]=font[f_seg_d];
		if (setup.kukuschka[1])
			lcd_buffer[2]=font[f_b];
			else
			lcd_buffer[2]=font[f_seg_d];
		if (setup.kukuschka[2])
			lcd_buffer[4]=font[f_N];
			else
			lcd_buffer[4]=font[f_seg_d];
		return;
		}
	//------------------------------------------
	if (regim==REG_SBROS_N){
		load_str_in_lcdbuffer(str_sbros_n);
		return;
		}
}

//**************************************
static void calls_verify(void)
{
unsigned char i;

	for(i=0;i<Count_bud;i++)
		if ( setup.budilnik[i][0] )//  
			if ( setup.budilnik[i][h_day] & _BV(hour[h_day]))//
				if (setup.budilnik[i][h_hour]==hour[h_hour])//
					if (setup.budilnik[i][h_min]==hour[h_min])//
						{
						BUDIL_OUT_ON;
						regim=REG_BUDILNIK_ON;
						time_signal=time_in_regim=60;
						signal=setup.budilnik[i][0];
						budilnik_nomer=i;
						budilnik_play_num=0;//           
						}
					
}

static void signal_verify(void){
	if (signal){
		if ( time_signal==0 ){
			BUDIL_OUT_OFF;
			if (signal==1) {
				signal=0;
				return;
				}
				else
			if (signal==2) {
				signal=3;
				time_signal=0xFF;
				}
				else
			if (signal==3) {
				if ( ++budilnik_play_num==7 ) signal=0;
				else{
					BUDIL_OUT_ON;
					regim=REG_BUDILNIK_ON;
					time_signal=time_in_regim=60;
					signal=2;
					}
				}
			}
		
		}
}

//**************************************
static void clock(void){

  if ( isr_1sek_ )// 
	{
	correct=0;
	if (++hour[h_sek]==60)
		{
		if (++hour[h_min]==60)
			{
			if ( setup.corr_flag&BIT(fl_corr_znak_pl) )// 
				correct=setup.correction;// 
				else
				correct= 0x00-setup.correction;
			
			hour[h_min] =0;
			hour[h_hour]++;
		
			if (hour[h_hour]==24)
				{
				hour[h_hour]=0;
				hour[h_day]++;
				hour[h_num]++;
				if (hour[h_day]>=7)	{hour[h_day]=0;}
				if (hour[h_num]>= num_in_month[hour[h_month]] )
					{
					hour[h_num]=0;
					hour[h_month]++;
					if (hour[h_month]>=12) 	{hour[h_month]=0;}
					}
				}
			if ( hour[h_hour] == setup.tim_c_light)	lcd_light=setup.night_light;
			if ( hour[h_hour] == setup.tim_do_light)	lcd_light=setup.day_light;
			if (lcd_light==setup.day_light) 
				{
				if (setup.kukuschka[0]) HOUR_OUT_ON;
				if (setup.kukuschka[1]) {BUDIL_OUT_ON;	time_signal=3; signal=1;}//3- 2 ,   time_direct    clock()
				if (setup.kukuschka[2]) bip_sig_on(10);
				}
				
			// / 
			//           2:00     1  
			//          3:00    1  .
			if ( hour[h_month]==3-1 ){//  
				if ( hour[h_num]>24-1 )//  25  
					if ( hour[h_day]==7-1 )// 
						if (hour[h_hour]==2) hour[h_hour]=3;
				}
			if ( hour[h_month]==10-1 ){//  
				if ( hour[h_num]>24-1 )//  25  
					if ( hour[h_day]==7-1 )// 
						if (hour[h_hour]==3) 
							{
							static uint8_t zimnie=0;
							if (zimnie==0){
								zimnie=1;
								hour[h_hour]=2;
								}
								else
								zimnie=0;
							}
				}
			}
		hour[h_sek] =0;
		calls_verify();
		}
	isr_1sek_=0;
	}
 		
}

void time_direct(void){
static unsigned char t, sek;
unsigned char i;
	if ( t != clock_ )
		{//  0,0078125 .
		t=clock_;
		if (t>=64) time_flag|=fl_sek_1_switch; else time_flag&=~fl_sek_1_switch;
		for (i=0; i<4; i++) time[i]--;
		
		if ( time_flag & fl_sig_butt )
			if (time[note_but]<0)
			{
			timer1_init();
			time_flag&= ~ fl_sig_butt;
			}
		
		skankey();
		key_action();

		if (sek!=hour[h_sek]){// 
			sek=hour[h_sek];
			time_signal--;
			if (regim==0)
				if (--current_state_view.time == 0 ) indikator_manager();
			if (--time_in_regim==0)
				if (regim>=10) regim=0;
			signal_verify();
			if (hour[h_sek]) HOUR_OUT_OFF;
			}
		
		if (regim>=10)
			{
			static uint8_t time_mig=0;
			if (++time_mig>=light_time_mig[lcd_light])
				{
				time_mig=0;
				change_light_var();
				}
			}
		}
}


//**************************************
int main(void)
{
	
	cli();
	read_data_EEPROM();
	
	if ( setup.day_light >= sizeof(light_disp) ) setup.day_light  =7;
	if ( setup.night_light >= sizeof(light_disp) ) setup.night_light=7;

	timer2_init();
	init_devices();

while(1)
{//while
	/* */
	clock();
	
	if (!pin_power_)
	{//begin power on
		time_flag&= ~ fl_power_save;

		time_direct();
				
		if (lcd_time_switch>=54)/* 0,0034 sek*/ 
	  	   	{
			lcd_time_switch=0x00;
			znakomesto++;
			
			#ifdef katod
			PORTSERIAL = BIT(STORAGE);
			#else
			PORTSERIAL = BIT(STORAGE)|0x1F;//   ,  .
			#endif
			
  	   		if  (znakomesto<5) 
				{
				#ifdef katod
				znakomesto_isr=(1<<znakomesto);
				#else
				znakomesto_isr=0x1F&(~(1<<znakomesto));
				#endif
				light_isr=light_disp[opred_light_current_num()];
				display();
				}
				else	
				{
				
				znakomesto=0xFF;

				if (regim){
					uint8_t l=setup.day_light;
					if ( setup.tim_do_light > setup.tim_c_light )
						{
						if ( (hour[h_hour] < setup.tim_do_light )&&( hour[h_hour] >= setup.tim_c_light ) ) 
							l=setup.night_light; else l=setup.day_light;
						}
						else
						{
						if ( (hour[h_hour] >= setup.tim_do_light )&&( hour[h_hour] < setup.tim_c_light ) ) 
							l=setup.day_light; else l=setup.night_light;
						}
					lcd_light=l;
					}
					
				data_lcd();
				//---------------
				if (regim>=10)
					time_flag|= fl_eeprom_write;
				if (regim==0)
					EEPROM_save_parametr_all();
				light_isr=100;//      isr
				lcd_time_switch=48;
				}
	  		}
		if (lcd_time_switch<7) izmerenie_t();	/* */

	}//end power on
	else
	{//begin power off
	time_flag|= fl_power_save;
	#ifdef katod
	//PORTLED&=PIN_SERIAL;
	PORTLED = BIT(STORAGE);//  
	#else
	//PORTLED|=~PIN_SERIAL;
	PORTLED = BIT(STORAGE)|0x1F;//.   
	#endif
	
	current_state_view.time=2;
	time_in_regim=2;	

	if ( signal || ( time_flag & fl_sig_butt ) )//          
		{
		time_direct();
		}
	
	if ( !(time_flag & fl_sig_butt) ){//        
		MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
		asm("sleep");
		MCUCR=0;
		}

	}//end power off

}//while

}
